/*
  Modul RELEs
  part of Arduino Mega Server project
  
*/

#ifdef RELE_FEATURE

// pins
#define rele1pin 32 // 
#define rele2pin 33 // 

#define RELE_ON   1
#define RELE_OFF  0

char rele1object[] = "rele1";
char rele2object[] = "rele2";

char rele1onMess[] = "On"; char rele1offMess[] = "Off";
char rele2onMess[] = "On"; char rele2offMess[] = "Off";

// states
  // 0 - off
  // 1 - on
  // 2 - not defined
  // 3 - not defined and not contXstatus
byte rele1state = 0;  byte rele1objectState = 2;  byte old_rele1state = 3;
byte rele2state = 0;  byte rele2objectState = 2;  byte old_rele2state = 3;

// init
void relesInit() {
  pinMode(rele1pin, OUTPUT);
  pinMode(rele2pin, OUTPUT);
  moduleReles = MODULE_ENABLE;
  started("Reles");

}

void relesWorks() {
  // rele1 
   
   if (rele1state != old_rele1state){                      // если 0 не равен 3
      old_rele1state = rele1state;                         // old_rele1state присваисаем 0
      if (rele1state == 1) {                               // если rele1state == 1 выполняем (rele1state == 0)
        digitalWrite(rele1pin, HIGH); 
        rele1objectState = RELE_ON;
        printContMess(rele1object, rele1onMess);
        #ifdef MAJORDOMO_FEATURE
          sendRequestM(rele1object, RELE_ON);
        #endif
      } else {                                             //  иначе
        digitalWrite(rele1pin, LOW);                       //  выключаем реле
        rele1objectState = RELE_OFF;
        printContMess(rele1object, rele1offMess);
        #ifdef MAJORDOMO_FEATURE
          sendRequestM(rele1object, RELE_OFF);
        #endif
      }
   }

  if (rele2state != old_rele2state){
      old_rele2state = rele2state;                         // тут ещё интересней
      digitalWrite(rele2pin, HIGH);                        // rele2state == 0 но мы включаем реле?
      if (rele2state == 1) {rele2objectState = RELE_ON;
        printContMess(rele2object, rele2onMess);
        #ifdef MAJORDOMO_FEATURE
          sendRequestM(rele2object, RELE_ON);
        #endif
        } else {
        digitalWrite(rele2pin, HIGH);
        rele2objectState = RELE_OFF;
        printContMess(rele2object, rele2offMess);
        #ifdef MAJORDOMO_FEATURE
          sendRequestM(rele2object, RELE_OFF);
        #endif
       }
  }

}
#endif // RELE_FEATURE
